#ifndef _KFbxNull_h
#define _KFbxNull_h

/**************************************************************************************

 Copyright  2003 - 2005 Systmes Alias Qubec Inc. and/or its licensors.  
 All rights reserved.

 The coded instructions, statements, computer programs, and/or related material 
 (collectively the "Data") in these files contain unpublished information proprietary
 to Systmes Alias Qubec Inc. and/or its licensors, which is protected by Canadian
 and US federal copyright law and by international treaties.

 The Data may not be disclosed or distributed to third parties, in whole or in part,
 without the prior written consent of Alias Systems Corp. (Alias).

 THE DATA IS PROVIDED AS IS AND WITHOUT WARRANTY. ALL WARRANTIES ARE EXPRESSLY
 EXCLUDED AND DISCLAIMED. ALIAS MAKES NO WARRANTY OF ANY KIND WITH RESPECT TO THE DATA,
 EXPRESS, IMPLIED OR ARISING BY CUSTOM OR TRADE USAGE, AND DISCLAIMS ANY IMPLIED
 WARRANTIES OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR FITNESS FOR A PARTICULAR 
 PURPOSE. IN NO EVENT SHALL ALIAS, ITS AFFILIATES, PARENT COMPANIES, LICENSORS OR 
 SUPPLIERS (ALIAS GROUP) BE LIABLE FOR ANY DAMAGES OR EXPENSES OF ANY KIND INCLUDING
 WITHOUT LIMITATION PUNITIVE OR MULTIPLE DAMAGES OR OTHER SPECIAL, DIRECT, INDIRECT, 
 EXEMPLARY, INCIDENTAL, OR CONSEQUENTIAL DAMAGES OF ANY KIND, WHETHER OR NOT ALIAS HAS
 BEEN ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWSOEVER CAUSED AND ON ANY THEORY OF
 LIABILITY. 

**************************************************************************************/

#include <kaydaradef.h>
#ifndef KFBX_DLL 
	#define KFBX_DLL K_DLLIMPORT
#endif

#include <kaydara.h>

#include <kfbxplugins/kfbxnodeattribute.h>

#include <kfbxplugins/kfbxnamespacedef.h>
namespace FBXSDK_NAMESPACE {

class KFbxSdkManager;
class KFbxNullProperties;

/**	This node attribute contains the properties of a null node.
  * \nosubgrouping
  */
class KFBX_DLL KFbxNull : public KFbxNodeAttribute
{

public:

 	//! Return the type of node attribute which is EAttributeType::eNULL.
	virtual EAttributeType GetAttributeType();
	 
    //! Reset to default values.
	void Reset();

	/**
	  * \name Null Properties
	  */
	//@{
	
	/** Set size.
	  * \param pSize Size of the graphical representaion of this object.
	  * \remarks The method does not check the passed value.
	  */
	void SetSize(double pSize);
	
	/** Get size.
	  * \return The currently set size.
	  */
	double GetSize();

	/** Get a flag to know if the size was set.
	  * \return \c true if someone called SetSize().
	  * \remarks When an attribute is not set, the application can choose to ignore the attribute or use the default value.
	  * \remarks The flag is set back to \c false when Reset() is called.
      */
	bool GetSizeIsSet();

	/** Get the default value for the size.
	  * \return 100
	  */
	double GetSizeDefaultValue();

	//@}

	//! Assignment operator.
    KFbxNull& operator=(KFbxNull& pNull);

///////////////////////////////////////////////////////////////////////////////
//
//  WARNING!
//
//	Anything beyond these lines may not be documented accurately and is 
// 	subject to change without notice.
//
///////////////////////////////////////////////////////////////////////////////

#ifndef DOXYGEN_SHOULD_SKIP_THIS

	// Property Handler
	KObject* GetPropertyHandler();

protected:

    KFbxNull(KFbxSdkManager& pManager);
	~KFbxNull();

	bool mSizeIsSet;

	virtual void FillPropertyList(void* pPropertyList);

	// Property Handler
	KFbxNullProperties* mPH;

	KString		GetTypeName();
	KStringList	GetTypeFlags();

	friend class KFbxSdkManager;
	friend class KFbxReaderFbx;
	friend class KFbxWriterFbx;
	friend class KFbxWriterFbx6;

#endif // #ifndef DOXYGEN_SHOULD_SKIP_THIS

};

typedef KFbxNull* HKFbxNull;

} // namespace
#endif // #ifndef _KFbxNull_h


