/****************************************************************************\
*                                                                            *
* 10.05.2006                                                                 *
* CPhysXActor - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CPHYSXACTOR_H__
#define __CPHYSXACTOR_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Math/TVector3.h>
#include <Math/CMatrix33.h>
#include "IPhysXObj.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class NxActor;

enum EForceMode
{
    EFM_FORCE,
    EFM_IMPULSE,
    EFM_VELOCITY,
};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CPhysXActor : public IPhysXObj
{
    friend class CPhysXMgr;
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        void SetPos(const CVector3f &vPos);
		void SetRot(const CVector3f &vRot);
		const CVector3f GetPos();
		const CVector3f GetRot();

        void SetGroup(word wGroup);
        void AddForce(const CVector3f &vForce, EForceMode mode);
        void AddTorque(const CVector3f &vForce, EForceMode mode);

		virtual ~CPhysXActor();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        CPhysXActor(NxActor *pActor);

        //Private copy constructor and assignment operator to prevent mistakes:
        CPhysXActor(const CPhysXActor &);
        const CPhysXActor &operator =(const CPhysXActor &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        NxActor *m_pActor;
};

#endif
