/****************************************************************************\
*                                                                            *
* 10.05.2006                                                                 *
* CPhysXCharacter - Header File                                              *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CPHYSXCHARACTER_H__
#define __CPHYSXCHARACTER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Math/TVector3.h>
#include "IPhysXObj.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class NxController;
class CPhysXActor;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CPhysXCharacter : public IPhysXObj
{
    friend class CPhysXMgr;
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        virtual void SetPos(const CVector3f &vPos);
        const CVector3f GetPos() const;

        virtual void Move(const CVector3f &vDistance, dword dwCollisionGroups);

        bool GroundContact() const;
        
        virtual ~CPhysXCharacter();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        CPhysXCharacter(NxController *pController);

        //Private copy constructor and assignment operator to prevent mistakes:
        CPhysXCharacter(const CPhysXCharacter &);
        const CPhysXCharacter &operator =(const CPhysXCharacter &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        NxController *m_pController;
        dword m_dwCollisionFlags;
};

#endif
