/****************************************************************************\
*                                                                            *
* 18.06.2003                                                                 *
* Definitions - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#ifndef _INC_WINDOWS    //THX for this fragment to Scott Bilas
	// tune windows.h
	#define WIN32_LEAN_AND_MEAN
	#define WIN32_EXTRA_LEAN
	#define STRICT
	// don't include this stuff (some of these are from AFXV_W32.H and may be deprecated - marked with '?')
	#define NOSERVICE			// - All Service Controller routines, SERVICE_ equates, etc.
	#define NOMCX				// - Modem Configuration Extensions
	#define NOIME				// <imm.h>
	#define NOSOUND				// - Sound driver routines
	#define NOCOMM				// - COMM driver routines
	#define NOKANJI				// - Kanji support stuff.
	#define NORPC				// ?
	#define NOPROXYSTUB			// ?
	#define NOIMAGE				// ?
	#define NOTAPE				// ?
	#define NOMETAFILE			// - typedef METAFILEPICT
	#define NOMINMAX			// - Macros min(a,b) and max(a,b) I define myself
	#define NOCRYPT				// crypto API
    #define _WIN32_WINNT 0x0500 //We are Win2000, WinXP or higher
// ok we're ready, finally include The Devil
	#include <windows.h>
#endif  // _INC_WINDOWS

#include <string>
#include <assert.h>

#pragma warning(disable: 4786)  //Switch off debug length warning (in vector)
#include <vector>


/****************************************************************************\
* DEFINITIONS	                                                             *
\****************************************************************************/

//Type redefinitions
typedef unsigned char byte;
typedef signed char sbyte;
typedef unsigned short word;
typedef signed short sword;
typedef unsigned long dword;
typedef signed long sdword;
typedef unsigned __int64 qword;
typedef signed __int64 sqword;

//Constants
const float MY_PI = 3.141592654f;


//#include <Memory/CLeakWatcher.h>
//#include <External/mmgr.h>
#include <Misc/CLogSystem.h>

#define SAFE_DELETE(p)                      {if(p) {delete (p);     (p) = NULL;}}
#define SAFE_DELETE_ARRAY(p)                {if(p) {delete [] (p);   (p) = NULL;}}

#endif
