/****************************************************************************\
*                                                                            *
* 16.04.2006                                                                 *
* CScrollXZCamCtrl - Header File                                                *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CSCROLLXZCAMCTRL_H__
#define __CSCROLLXZCAMCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/TSmartPointer.h>
#include <Input/IInputHandler.h>
#include <Math/TAABox3.h>
#include "ICamCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CCamera;
#include <Timer/CTimer.h>

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CScrollXZCamCtrl : public ICamCtrl, private IInputHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CScrollXZCamCtrl(float fScrollFrame, CAABox3f scrollArea, float fSpeed,  //fScrollFrame = area of the window, where the mouse should scroll
                         const TSmartPointer<CTimer> &pTimer, word wInputPriority);
        
        void Enable(const TSmartPointer<CCamera> &pCamera);
        void Update();
        void Disable();
        
        virtual ~CScrollXZCamCtrl();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        virtual bool OnKeyDown(dword dwKey);
        virtual bool OnKeyUp(dword dwKey);

        //Private copy constructor and assignment operator to prevent mistakes:
        CScrollXZCamCtrl(const CScrollXZCamCtrl &);
        const CScrollXZCamCtrl &operator =(const CScrollXZCamCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        CAABox3f m_ScrollArea;
        float m_fScrollFrame;
        float m_fSpeed;

        bool m_bForward, m_bBackward;
        bool m_bLeft, m_bRight;

        TSmartPointer<CTimer> m_pTimer;
};

#endif
