/****************************************************************************\
*                                                                            *
* 26.03.2006                                                                 *
* CGuiText - Source File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CGuiText.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void CGuiText::SetPos(const CVector3f &vPos)
{
    IGuiObject::SetPos(vPos);
}

void CGuiText::SetText(const std::string &sText)
{
    m_TextInfo.m_text = sText;
}

void CGuiText::SetColor(dword dwColor)
{
    m_TextInfo.m_textColor[0] = ((float)((dwColor & 0xFF000000) >> 24)) / 256.0f;
    m_TextInfo.m_textColor[1] = ((float)((dwColor & 0x00FF0000) >> 16)) / 256.0f;
    m_TextInfo.m_textColor[2] = ((float)((dwColor & 0x0000FF00) >>  8)) / 256.0f;
    m_TextInfo.m_textColor[3] = ((float)((dwColor & 0x000000FF)      )) / 256.0f;
}

void CGuiText::Destroy()   
{
    IGuiObject::Destroy();
    Clear();
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/
CGuiText::CGuiText(const TSmartPointer<IFont> &pFont) : IGuiObject()
{
    Clear();
    assert((bool) pFont && "Error: NULL Font in CGuiText constructor");
    m_pFont = pFont;

    m_TextInfo.m_vPos.Set(0.0f, 0.0f, 0.2f);
}

void CGuiText::RenderSub()
{
    assert((bool) m_pFont && "Error: NULL Font in CGuiText::Render");
    m_pFont->RenderText(&m_TextInfo);
}

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/
void CGuiText::Clear()   
{
    m_pFont = NULL;
}
