/****************************************************************************\
*                                                                            *
* 22.02.2006                                                                 *
* CConsoleWindow - Header File                                               *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __CCONSOLEWINDOW_H__
#define __CCONSOLEWINDOW_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CConsoleWindow
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CConsoleWindow() {Clear();}
        bool Create(const std::string &sTitle, word wWidth = 80, word wHeight = 25, sword swPosX = 0, sword swPosY = 0);

        void Destroy();
        virtual ~CConsoleWindow() {Destroy();}

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        void Clear();
        //Private copy constructor and assignment operator to prevent mistakes:
        CConsoleWindow(const CConsoleWindow &);
        CConsoleWindow &operator =(const CConsoleWindow &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        word m_wWidth;
        word m_wHeight;

        HANDLE m_hBuffer;

        FILE *m_pInFile;
        FILE *m_pOutFile;
        FILE *m_pErrFile;        
};

#endif
