/****************************************************************************\
*                                                                            *
* 16.02.2006                                                                 *
* IWindowHandler - Header File                                               *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __IWINDOWHANDLER_H__
#define __IWINDOWHANDLER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

#include <Memory/IManagedObject.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IWindowHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        IWindowHandler() {}
        virtual void OnWndSize(word wWidth, word wHeight) {}
													//Is called whenever the window gets resized

        virtual void OnWndChar(char c) {}           //Is called whenever a character is received
        virtual void OnWndActivate(bool bActive) {} //Is called whenever the window gets or loses the focus

        virtual void OnWndDestroy() {}              //Is called when the window is destroyed
        virtual void OnPreFullscreen(bool bFullscreen) {} //Is called before the window switches to bFullscreen
        virtual void OnPostFullscreen(bool bFullscreen) {} //Is called after the window enters/leaves fullscreen mode
        
        virtual ~IWindowHandler() {}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IWindowHandler(const IWindowHandler &);
        IWindowHandler &operator =(const IWindowHandler &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
