/****************************************************************************\
*                                                                            *
* 21.02.2006                                                                 *
* IInputHandler - Header File                                                *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __IINPUTHANDLER_H__
#define __IINPUTHANDLER_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
const dword cg_dwKeyEsc         = 0x00000001;
const dword cg_dwKeySpace       = 0x00000039;
const dword cg_dwKeyLShift      = 0x0000002a;
const dword cg_dwCursorUp       = 0x000000C8;
const dword cg_dwCursorDown     = 0x000000D0;
const dword cg_dwCursorLeft     = 0x000000CB;
const dword cg_dwCursorRight    = 0x000000CD;
const dword cg_dwKeyW           = 0x00000011;
const dword cg_dwKeyS           = 0x0000001f;
const dword cg_dwKeyA           = 0x0000001e;
const dword cg_dwKeyD           = 0x00000020;
const dword cg_dwKeyG           = 0x00000022;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IInputHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        IInputHandler() {SetPriority(1000);}
        IInputHandler(word wPriority) {SetPriority(wPriority);}

        virtual bool OnMouseMove(sdword sdwX, sdword sdwY, sdword sdwZ) {return false;}
        virtual bool OnMouseKeyDown(byte bKey) {return false;}
        virtual bool OnMouseKeyUp(byte bKey) {return false;}
        virtual bool OnChar(char c) {return false;}
        virtual bool OnKeyDown(dword dwKey) {return false;}
        virtual bool OnKeyUp(dword dwKey) {return false;}

        virtual void SetPriority(word wPriortiy) {m_wPriority = wPriortiy;}
        virtual word GetPriority() {return m_wPriority;}

        virtual ~IInputHandler() {};

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IInputHandler(const IInputHandler &);
        IInputHandler &operator =(const IInputHandler &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        word m_wPriority;
        
};

#endif
