/****************************************************************************\
*                                                                            *
* 29.03.2006                                                                 *
* TPlane - Header File                                                       *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __TPLANE_H__
#define __TPLANE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "TVector3.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
template<typename T>
class TPlane
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        TPlane() {}
        TPlane(const T &a, const T &b, const T &c, const T &d) {m_A = a; m_B = b; m_C = c; m_D = d;}
        TPlane(const TPlane<T> &other) {m_A = other.m_A; m_B = other.m_B; m_C = other.m_C; m_D = other.m_D;}
        const TPlane<T> &operator =(const TPlane &other) {m_A = other.m_A; m_B = other.m_B; m_C = other.m_C; m_D = other.m_D; return *this;}

        void Set(const T &a, const T &b, const T &c, const T &d) {m_A = a; m_B = b; m_C = c; m_D = d;}

        inline T Distance(const TVector3<T> &vec) const
        {
            return m_A * vec.m_X + m_B * vec.m_Y + m_C * vec.m_Z + m_D;
        }
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        
    /**************************************************************************\
    * PUBLIC CLASS MEMBERS                                                     *
    \**************************************************************************/
    public:
        T m_A, m_B, m_C, m_D;
};

typedef TPlane<float> CPlanef;

#endif