/****************************************************************************\
*                                                                            *
* 18.06.2003                                                                 *
* CLogSystem - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __CLOGSYSTEM_H__
#define __CLOGSYSTEM_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

/****************************************************************************\
* DEFINITIONS	                                                              *
\****************************************************************************/
enum ETargetLog
{
  TL_ERROR   =  1,
  TL_STDERR  =  2,
  TL_STDOUT  =  4,
  TL_USER    =  8,
#ifdef _DEBUG
  TL_DEBUG   =  16,
#else
  TL_DEBUG   =  0,      //Debug-Ausgaben werden in Release-Builds verworfen
#endif
};

#define LOG CLogSystem::Log

#ifdef _DEBUG
    #define DEBUGLOG(bCondition, sString) if(bCondition) {LOG(TL_USER | TL_DEBUG, sString);}
#else
    #define DEBUGLOG(bCondition, sString)
#endif

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CLogSystem
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        static void ClearLogs();
        static void Log(word wTargetLog, const char* sText, ...);

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        CLogSystem();
};

#endif
