/****************************************************************************\
*                                                                            *
* 01.06.2006                                                                 *
* COGLCGSimpleBump - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __COGLCGSimpleBump_H__
#define __COGLCGSimpleBump_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Renderer/coglcg/COGLCGProgram.h>
#include <Math/CMatrix44.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class COGLCGSimpleBump : public COGLCGProgram
{
	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	COGLCGSimpleBump(COGLTriangleGroup *pTri, COGLRenderer *pRenderer);

	bool Create(dword normalMapTexID,dword colorMapTexID);
	virtual void SetupAndBind();
	virtual void Unbind();

	virtual ~COGLCGSimpleBump();

	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	//Private copy constructor and assignment operator to prevent mistakes:
	COGLCGSimpleBump(const COGLCGSimpleBump &);
	COGLCGSimpleBump &operator =(const COGLCGSimpleBump &);
	
	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:

	virtual void Destroy();

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:

	dword     * m_pIndices;
	CVector3f * m_pCoords;
	CVector3f * m_pNormals;
	CVector2f * m_pUvs;
	CVector4f * m_pVertexTangents;

	dword       m_ColorMapTexID;
	CVector4f * m_pAmbientColor;
	CVector4f * m_pSpecularColor;
	float     * m_exp;

	dword m_NormalMapTexID;

	CMatrix44        m_mat;
	CVector3f        m_vec;
	CVector3f        m_vCamPos;
	
	CGparameter cgVp_camPos;
	CGparameter cgVp_modelViewMatrix;
	CGparameter cgVp_lightDirection;

	CGparameter cgFp_lightDiffuseColor;

	CGparameter cgFp_ambientColor;
	CGparameter cgFp_specularColor;
	CGparameter cgFp_exp;

};

#endif

