/****************************************************************************\
*                                                                            *
* 06.06.2006                                                                 *
* COGLMultiPass - Header File                                                *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __COGLMULTIPASS_H__
#define __COGLMULTIPASS_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Memory/TSmartPointer.h>
#include <Display/Camera/CCamera.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
enum EMultiPassEffect{
	eMotionBlur,
	eFullSceneAntiAliasing,
	eDepthOfField
};

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class COGLMultiPass{

	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	
	COGLMultiPass(){}

	virtual bool Create(TSmartPointer<CCamera> pCamera,byte nmbPasses);
	virtual void BeginMultiPass(EMultiPassEffect eMode);
	virtual void NextPass();
	virtual void EndMultiPass();

	byte m_nmbPasses;
	byte m_currentPass;

	virtual ~COGLMultiPass(){m_pCamera = NULL;}

		/**************************************************************************\
		* PROTECTED CLASS FUNCTIONS                                                *
		\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	//Private copy constructor and assignment operator to prevent mistakes:
	COGLMultiPass(const COGLMultiPass &);
	COGLMultiPass &operator =(const COGLMultiPass &);

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:
	
	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:

	TSmartPointer<CCamera> m_pCamera;
	

};

#endif


