/****************************************************************************\
*                                                                            *
* 29.04.2006                                                                 *
* COGLStockGeometry - Source File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "COGLStockGeometry.h"
#include <Renderer/COGLRenderer.h>
#include <Renderer/COGLModelFactory.h>

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

COGLStockGeometry::COGLStockGeometry(COGLRenderer *pRenderer,COGLModelFactory *pHost, word dispListNmb, EBlendingMode blendingMode){
	m_pHost       = pHost;
	m_pRenderer   = pRenderer;
	m_dispListNmb = dispListNmb;
	m_BlendingMode = blendingMode;
}

void COGLStockGeometry::Render(){
	m_pRenderer->RenderStockObject(this);
}

void COGLStockGeometry::Destroy(){
	m_pRenderer->Free(this);
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/


