/****************************************************************************\
*                                                                            *
* 13.06.2006                                                                 *
* IGlobalRenderSettings - Header File                                        *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IGLOBALRENDERSETTINGS_H__
#define __IGLOBALRENDERSETTINGS_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
#include <Renderer/COGLRenderInfo.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class IRenderer;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IGlobalRenderSettings : public IManagedObject{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		IGlobalRenderSettings(){}

		virtual bool IsGlobalRenderStateSet() = 0;

		virtual void DisableAllRenderFeatures() = 0;
		virtual void EnableAllRenderFeatures() = 0;

		virtual void StoreGlobalRenderState() = 0;
		virtual void RestoreGlobalRenderState() = 0;

		virtual void EnableVertexColors(bool bEnable) = 0;
		virtual void EnableLighting(bool bEnable) = 0;
		virtual void EnableTexturing(bool bEnable) = 0;
		virtual void EnableShader(bool bEnable) = 0;

		virtual void SetMipMappingOverride(bool bEnable) = 0;
		virtual void SetTextureQualityOverride(EOGLTextureQuality eQuality, bool bEnable) = 0;

		virtual ~IGlobalRenderSettings(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IGlobalRenderSettings(const IGlobalRenderSettings &);
        IGlobalRenderSettings &operator =(const IGlobalRenderSettings &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
};

#endif