/****************************************************************************\
*                                                                            *
* 26.04.2006                                                                 *
* ISound - Header File                                                       *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __ISOUND_H__
#define __ISOUND_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>
/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ISound : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
		ISound(){m_volume = 1.0f;m_loopCount=0;}

		virtual void Play()  = 0;
		virtual void Pause() = 0;
		virtual void Stop()  = 0;

		void  SetVolume(float vol){m_volume = vol;}
		void  SetLoopCount(word nmb){m_loopCount = nmb;}
		float GetVolume(){return m_volume;}
		word  GetLoopCount(){return m_loopCount;}
      
		virtual ~ISound(){}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        ISound(const ISound &);
        ISound &operator =(const ISound &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:

		float m_volume;
		word  m_loopCount;
        
};

#endif
