/****************************************************************************\
*                                                                            *
* 24.02.2006                                                                 *
* CW32TimeSource - Source File                                               *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CW32TimeSource.h"
#include <mmsystem.h>

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
CW32TimeSource::CW32TimeSource()
{
    LARGE_INTEGER li;

    if(::QueryPerformanceFrequency(&li))
        m_dSecondsPerTick = 1.0/li.QuadPart;
    else
        m_dSecondsPerTick = 0.001;
}

double CW32TimeSource::GetTime() const
{
    LARGE_INTEGER li;

    if(QueryPerformanceCounter(&li))
        return li.QuadPart * m_dSecondsPerTick;
    else
        return timeGetTime() * m_dSecondsPerTick;

}