/****************************************************************************\
*                                                                            *
* 24.02.2006                                                                 *
* ITimeSource - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __ITIMESOURCE_H__
#define __ITIMESOURCE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class ITimeSource : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        ITimeSource() {}
        virtual double GetTime() const = 0;

        virtual ~ITimeSource() {}
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        ITimeSource(const ITimeSource &);
        ITimeSource &operator =(const ITimeSource &);
};

#endif
