/****************************************************************************\
*                                                                            *
* 15.03.2006                                                                 *
* CSettings - Header File                                                    *
*                                                                            *
* ((c) Raphael Charwot, Robert Hausmair                                      *
*                                                                            *
\****************************************************************************/

#ifndef __CSETTINGS_H__
#define __CSETTINGS_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>
#include <Memory/mmgr.h>
#include "Misc/TSingleton.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

class CIniFile;

#ifndef SETTINGS_FILENAME
	#define SETTINGS_FILENAME "settings.ini"
#endif

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CSettings : public TSingleton<CSettings>
{
	friend class TSingleton;

	/****************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                  *
	\****************************************************************************/
protected:
	
	CSettings();
	~CSettings(void);

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                     *
	\**************************************************************************/
private:
	
	CIniFile    *p_iniFile;
	std::string  m_settingsFileName;

	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	
	bool Load(char *);
	bool GetValue(const std::string &sCategory,const std::string &sName, std::string &sValue);
	bool SetValue(const std::string &sCategory,const std::string &sName,const std::string &sValue);
	void Clear();
	bool SaveAs(char *);
	
};

#endif