/****************************************************************************\
*                                                                            *
* 02.05.2006                                                                 *
* CAiTowerCtrl - Header File                                                 *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CAITOWERCTRL_H__
#define __CAITOWERCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Misc/IObserver.h>
#include "ITowerCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CGameCtrl;
class CBirdObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CAiTowerCtrl : public ITowerCtrl, private IObserver
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CAiTowerCtrl(CGameCtrl *pGameCtrl);

		virtual void Update(float dt);

        virtual bool GetRot(CVector3f &vRot);
        virtual bool Shoot();

        virtual ~CAiTowerCtrl();

    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        virtual void Notify();

        //Private copy constructor and assignment operator to prevent mistakes:
        CAiTowerCtrl(const CAiTowerCtrl &);
        const CAiTowerCtrl &operator =(const CAiTowerCtrl &);

    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:

    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		CGameCtrl *m_pGameCtrl;
		CBirdObj *m_pNextTarget;
		CVector3f m_vRot;
};

#endif
