/****************************************************************************\
*                                                                            *
* 03.06.2006                                                                 *
* CHqBuildingObj - Source File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CHqBuildingObj.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/
const float cg_fHqMaxHitpoints = 400.0f;

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
CHqBuildingObj::CHqBuildingObj(CGameCtrl *pGameCtrl, const TSmartPointer<IFunctor> &pHqDestroyedCb,
							   const TSmartPointer<IParamFunctor> &pHqHitCb)
							   : CBuildingObj(pGameCtrl,
							   "Data/models/buildings/statue.fbx",
							   cg_fHqMaxHitpoints, 100.0f, ECG_BUILDING),
							   m_pHqDestroyedCallback(pHqDestroyedCb), m_pHqHitCallback(pHqHitCb)
{
}

void CHqBuildingObj::SetHitpoints(float fHitpoints)
{
	if(fHitpoints < 0.0f)
		fHitpoints = 0.0f;
	CBuildingObj::SetHitpoints(fHitpoints);
	if(m_pHqHitCallback)
	{
		(*m_pHqHitCallback)((dword) (100.0f * fHitpoints / cg_fHqMaxHitpoints));
	}
	if(GetState() == EBS_DESTROYED)
	{
		if(m_pHqDestroyedCallback)
		{
			(*m_pHqDestroyedCallback)();
		}
	}
}


CHqBuildingObj::~CHqBuildingObj()
{

}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/