/****************************************************************************\
*                                                                            *
* 03.06.2006                                                                 *
* CTowerObj - Header File                                          *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CTOWEROBJ_H__
#define __CTOWEROBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "CBuildingObj.h"
#include "ITowerCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CTowerObj : public CBuildingObj
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CTowerObj(CGameCtrl *pGameCtrl);
        
		void SetTowerCtrl(const TSmartPointer<ITowerCtrl> &pTowerCtrl);
        const CVector3f GetShootingPos() const;

        virtual ~CTowerObj();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
		virtual void SubUpdate(float dt);
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        CTowerObj(const CTowerObj &);
        const CTowerObj &operator =(const CTowerObj &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		TSmartPointer<ITowerCtrl> m_pTowerCtrl;
		float m_fAttackDelay;
};

#endif
