/****************************************************************************\
*                                                                            *
* 30.04.2006                                                                 *
* CHumanPlayerCtrl - Header File                                             *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CHUMANPLAYERCTRL_H__
#define __CHUMANPLAYERCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "IPlayerCtrl.h"
#include <Input/IInputHandler.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CHumanPlayerCtrl : public IPlayerCtrl, private IInputHandler
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CHumanPlayerCtrl(word wInputPriority);

        virtual void SetPlayer(CPlayerObj *pPlayer);
        virtual void GetDirection(CVector3f &vDirection);
        virtual bool GetRot(CVector3f &vRot);
        virtual bool Shoot();
        virtual bool Jump();
		virtual bool Run();
        
        virtual ~CHumanPlayerCtrl();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        virtual bool OnMouseMove(sdword sdwX, sdword sdwY, sdword sdwZ);
		virtual bool OnMouseKeyDown(byte bKey);
        virtual bool OnKeyDown(dword dwKey);
        virtual bool OnKeyUp(dword dwKey);

        //Private copy constructor and assignment operator to prevent mistakes:
        CHumanPlayerCtrl(const CHumanPlayerCtrl &);
        const CHumanPlayerCtrl &operator =(const CHumanPlayerCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        bool m_bForward, m_bBackward;
        bool m_bLeft, m_bRight;
        bool m_bJump;
		bool m_bShoot;
		bool m_bRun;

        CVector3f m_vRot;
        bool m_bRotChanged;
};

#endif
