/****************************************************************************\
*                                                                            *
* 22.05.2006                                                                 *
* CProjectileObj - Header File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CPROJECTILEOBJ_H__
#define __CPROJECTILEOBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "ICollidableObj.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CProjectileObj : public ICollidableObj
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CProjectileObj(CGameCtrl *pGameCtrl, EObjectType type, byte bCollisionGroup, const std::string &sModel);
        
		virtual void SetPos(const CVector3f &vPos);
		virtual void CollidedWith(IGameObj *pOther);
		virtual void LevelDone();
        
		virtual void Notify();
        virtual ~CProjectileObj();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
		virtual void SubUpdate(float dt);

        //Private copy constructor and assignment operator to prevent mistakes:
        CProjectileObj(const CProjectileObj &);
        const CProjectileObj &operator =(const CProjectileObj &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
		CVector3f m_vLastPos;

		float m_fStateTime;
		IGameObj *m_pStickObj;
		CVector3f m_vStickOffset;
		CVector3f m_vStickOffsetRotation;
		CVector3f m_vStickRotation;
};

#endif
