/****************************************************************************\
*                                                                            *
* 07.05.2006                                                                 *
* CStartObj - Header File                                                 *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CSTARTOBJ_H__
#define __CSTARTOBJ_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "Objects/ICollidableObj.h"
#include "CGameCtrl.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CStartObj : public ICollidableObj
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        CStartObj(CGameCtrl *pGameCtrl, const CVector3f &vPos);

		virtual void CollidedWith(IGameObj *pOther);
		virtual void LevelDone();

        virtual ~CStartObj();
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        virtual void SubUpdate(float dt);

        //Private copy constructor and assignment operator to prevent mistakes:
        CStartObj(const CStartObj &);
        const CStartObj &operator =(const CStartObj &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
};

#endif
