/****************************************************************************\
*                                                                            *
* 06.05.2006                                                                 *
* CEnvironment - Header File                                                     *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __CENVIRONMENT_H__
#define __CENVIRONMENT_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include "Objects/IGameObj.h"
#include "CEnvironmentRep.h"

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class CEnvironment : public IGameObj
{
	/**************************************************************************\
	* PUBLIC CLASS FUNCTIONS                                                   *
	\**************************************************************************/
public:
	CEnvironment(CGameCtrl *pGameCtrl) : IGameObj(pGameCtrl, EOT_UNKNOWN) {}

	bool Create(const std::string  & sLevel);

	virtual void Destroy(){}
	
	virtual ~CEnvironment(){Destroy();}

	TSmartPointer<IRepresentation> getEnvironmentRep(){return m_pRepresentation;}
	const CVector3f &GetSunDir() const {return m_vSunDir;}
	const CVector4f &GetSunAmbientColor() const {return m_vSunAmbientColor;}
	const CVector4f &GetSunDiffuseColor() const {return m_vSunDiffuseColor;}


	/**************************************************************************\
	* PROTECTED CLASS FUNCTIONS                                                *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS FUNCTIONS                                                  *
	\**************************************************************************/
private:
	virtual void SubUpdate(float dt) {}
	//Private copy constructor and assignment operator to prevent mistakes:
	CEnvironment(const CEnvironment &);
	const CEnvironment &operator =(const CEnvironment &);

	/**************************************************************************\
	* PROTECTED CLASS MEMBERS                                                  *
	\**************************************************************************/
protected:

	/**************************************************************************\
	* PRIVATE CLASS MEMBERS                                                    *
	\**************************************************************************/
private:
	CVector3f m_vSunDir;
	CVector4f m_vSunDiffuseColor;
	CVector4f m_vSunAmbientColor;
};

#endif
