/****************************************************************************\
*                                                                            *
* 30.04.2006                                                                 *
* IPlayerCtrl - Header File                                                  *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IPLAYERCTRL_H__
#define __IPLAYERCTRL_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Math/TVector3.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CPlayerObj;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IPlayerCtrl
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        IPlayerCtrl() {m_pPlayer = NULL;}

        virtual void SetPlayer(CPlayerObj *pPlayer) {m_pPlayer = pPlayer;}
        virtual void GetDirection(CVector3f &vDirection) = 0;
        virtual bool GetRot(CVector3f &vRot) = 0;
        virtual bool Shoot() = 0;
        virtual bool Jump() = 0;
		virtual bool Run() = 0;
        
        virtual ~IPlayerCtrl() {}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IPlayerCtrl(const IPlayerCtrl &);
        const IPlayerCtrl &operator =(const IPlayerCtrl &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        CPlayerObj *m_pPlayer;
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
        
};

#endif
