/****************************************************************************\
*                                                                            *
* 21.04.2006                                                                 *
* CPostLevelState - Source File                                               *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include "CPostLevelState.h"
#include "CGameCtrl.h"
#include "CSettings.h"
#include "CPostGameState.h"

/****************************************************************************\
* PRIVATE DEFINITIONS                                                        *
\****************************************************************************/

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
bool CPostLevelState::Create(CGameCtrl *pGameCtrl)
{
	if(!IGameState::Create(pGameCtrl))
		return false;

	std::string sValue;
	if(CSettings::InstancePtr()->GetValue("GAME", "NumLevels", sValue))
	{
		m_wNumLevels = (word) strtoul(sValue.c_str(), NULL, 10);
	}

	return true;
}

void CPostLevelState::Enter()
{
}

bool CPostLevelState::Update()
{
	m_pGameCtrl->LevelDone();

	//Gibt es noch ein level?
	if(m_wNumLevels > m_pGameCtrl->GetLevel())
	{
		//Switch to next level
		m_pGameCtrl->SetCurrentState(m_pGameCtrl->GetNewLevelState());
	}
	else
	{
		m_pGameCtrl->GetPostGameState()->GameWon(true);
		m_pGameCtrl->SetCurrentState(m_pGameCtrl->GetPostGameState());
	}

    return true;
}

void CPostLevelState::Leave()
{
}

void CPostLevelState::Destroy()
{
    IGameState::Destroy();
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/