/****************************************************************************\
*                                                                            *
* 04.04.2006                                                                 *
* IGameState - Header File                                                   *
*                                                                            *
* (c) Raphael Charwot, Robert Hausmair                                       *
*                                                                            *
\****************************************************************************/

#ifndef __IGAMESTATE_H__
#define __IGAMESTATE_H__

/****************************************************************************\
* REQUIRED HEADERS                                                           *
\****************************************************************************/
#include <Definitions.h>

#include <Memory/mmgr.h>
#include <Memory/IManagedObject.h>

/****************************************************************************\
* DEFINITIONS                                                                *
\****************************************************************************/
class CGameCtrl;

/****************************************************************************\
* CLASS                                                                      *
\****************************************************************************/
class IGameState : public IManagedObject
{
    /**************************************************************************\
    * PUBLIC CLASS FUNCTIONS                                                   *
    \**************************************************************************/
    public:
        IGameState() {}
        
        virtual bool Create(CGameCtrl *pGameCtrl) {m_pGameCtrl = pGameCtrl; return true;}
        virtual void Enter() = 0;
        virtual bool Update() = 0;
        virtual void Leave() = 0;
        virtual void Destroy() {m_pGameCtrl = NULL;}
        
        virtual ~IGameState() {Destroy();}
        
    /**************************************************************************\
    * PROTECTED CLASS FUNCTIONS                                                *
    \**************************************************************************/
    protected:
        
    /**************************************************************************\
    * PRIVATE CLASS FUNCTIONS                                                  *
    \**************************************************************************/
    private:
        //Private copy constructor and assignment operator to prevent mistakes:
        IGameState(const IGameState &);
        const IGameState &operator =(const IGameState &);
        
    /**************************************************************************\
    * PROTECTED CLASS MEMBERS                                                  *
    \**************************************************************************/
    protected:
        CGameCtrl *m_pGameCtrl;
        
    /**************************************************************************\
    * PRIVATE CLASS MEMBERS                                                    *
    \**************************************************************************/
    private:
};

#endif
